


clear all
close all

L = linspace(-2,2,1000);

% CHORIZO
p = [0 0.2 0;
    0 0 0.2;
    0 0 0];

C(1,:) = p(1,1) + p(1,2)*L + p(1,3)*L.^2;
C(2,:) = p(2,1) + p(2,2)*L + p(2,3)*L.^2;
C(3,:) = p(3,1) + p(3,2)*L + p(3,3)*L.^2;

C(3,:) = C(2,:).^3;

for nn=1:size(C,2)
    dat_aux(:,nn) = C(:,nn) + 0.05*(nn+100)/size(C,2)*randn(3,1);
end

dat_aux(2:3,:) = dat_aux(2:3,:)/2;

figure, plot3(dat_aux(1,:),dat_aux(2,:),dat_aux(3,:),'.')
axis equal

ii = randperm(size(dat_aux,2));
dat = dat_aux(:,ii(1:800));
dat_test = dat_aux(:,ii(801:end));

%%%%%%%%%%%%%%%%%%%
% PARAMETERS OF SPCA
%%%%%%%%%%%%%%%%%%%


N_data = length(dat(1,:));          % Number of training samples
N_samples = length(dat_test(1,:));  % Number of test samples

criterio = 2;   % metric criterion (1 stands for euclidean metric, 2 stands for infomax, and 3 stands for error minimization)
tol = 0.1;              % tolerance in for the inversion error

pto = dat(:,1);        % coordinate origin


Btotal = 7;             % number of bits to be distributed among dimensions.

% If zero is given to the following variables, the initialization
% function looks for a default value for them.

Nbins = 0;    % Number of bins (resolution) in each dimension e.g. Nbins = [N1, N2, ..., Nd]
DIST = 0;     % Euclidean distance threshold for the "out-of-the-manifold" condition
Aref = 0;     % Reference matrix with the local PCA directions at the origin

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%   INITIALIZATION (on training data):
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

TAU = 0.001:0.0005:0.022;%[0.0025 0.005 0.0075 0.01 0.0125];
Q = 0.0001:0.0025:0.14;%[0.01 0.03 0.05 0.7 0.9 0.11];
NV = [0.1];
ERR = [];
for ind_Nv = 1:length(NV)
    figure
    Nv = NV(ind_Nv)*N_data;
    kkk=1;
    for ind_tau = 1:length(TAU)
        tau = TAU(ind_tau);

        for ind_q = 1:length(Q)

            q  = Q(ind_q);
            [init_param] = initialize_SPCA_2(dat,pto,Nv,tau,q,criterio,Btotal,Nbins,DIST,Aref);

            Res(ind_tau,ind_q).param_PC = init_param.eucl_PC;
            Res(ind_tau,ind_q).tau = init_param.tau;
            Res(ind_tau,ind_q).q = init_param.q;

            % subplot(length(TAU),length(Q),kkk)
            % kkk=kkk+1;
            % plot3(dat(1,:),dat(2,:),dat(3,:),'.'), axis square, axis equal
            % plotea_eje(init_param.eucl_PC,'k.-')
            % view(2)
            % title(['t: ' num2str(ind_tau) ' q: ' num2str(ind_q)])

            ERR(ind_Nv,ind_tau,ind_q) = sum(sqrt(sum((dat-init_param.points_on_eucl_PC).^2))/size(dat,2));
            [ind_tau ind_q]
        end
    end
end

% figure,plot3(dat(1,:),dat(2,:),dat(3,:),'.'), axis square, axis equal
% plotea_eje(init_param.PC,'k.-')
% title(['Principal Curve modified metric'])

aux =[];
aux(:,:) = ERR(nn,:,:);
figure,imagesc(TAU,Q,aux)

[XX YY] = meshgrid(Q,TAU);
figure,mesh(XX,YY,aux)

figure,imagesc(TAU,Q,1-log(aux))

[XX YY] = meshgrid(Q,TAU);
figure,mesh(XX,YY,log(aux))

min(ERR)

%%%%%%%%%%%%%%%%%%%%%
%%% CONCLUSIONES:
%%%  tau = 0.01, q = 0.05, Nv = 0.1;
%%%%%%%%%%%%%%%%%%%%


Nv = 0.1*N_data;
tau = 0.01;
q  = 0.05;
[init_param] = initialize_SPCA_2(dat,pto,Nv,tau,q,criterio,Btotal,Nbins,DIST,Aref);

figure
plot3(dat(1,:),dat(2,:),dat(3,:),'.'), axis square, axis equal
plotea_eje(init_param.eucl_PC,'k.-')


%
% ERR(ind_Nv,ind_tau,ind_q) = sum(sqrt(sum((dat-init_param.points_on_eucl_PC).^2))/size(dat,2));
% view(2)
