function Ao=alinea_bases(A,T,opcion);

% ALINEA_BASES ordena las columnas (base) de la matriz A para maximizar su
% coincidencia con las columnas (base) de la matriz de referencia T.
%
% Admitimos dos posibilidades para el calculo de la 'coincidencia':
%
%    opcion = 1 ...... Asigna vector a vector por el maximo del producto escalar
%    opcion = 2 ...... Elige la ordenacion que maximiza la suma de las proyecciones
%
% USO:  A_ord=alinea_bases(A,T,opcion);

NA=sqrt(sum(A.^2));
NT=sqrt(sum(T.^2));

D=size(A);

An=A./NA( ones(D(1),1), :);
Tn=T./NT( ones(D(1),1), :);

Ao=A;


if opcion==1

    prods_esc=Tn'*An;

    % Opcion 1: asignar por maximo de la proyeccion
    
    for i=1:D(1)
        pm=max(max(abs(prods_esc)));
        [f,c]=find(abs(prods_esc)==pm);
   
        Ao(:,f(1))=sign(prods_esc(f(1),c(1)))*A(:,c(1));
        prods_esc(f(1),:)=0;
        prods_esc(:,c(1))=0;    
    end    
    
else
    
    % Opcion 2: maximizar la suma de las proyecciones (busqueda exhaustiva)
    
    permus=perms(1:D(1));
    
    for i=1:length(permus(1,:))
        prods_esc(i)=sum(abs(diag(Tn'*An(:,permus(i,:)))));
    end
    [m,ind]=max(prods_esc);
        
    Ao=sign(  repmat(diag(Tn'*An(:,permus(ind,:)))',D(1),1)  ).*A(:,permus(ind,:));
    
end
