function [pto_proximo,Aref] = inv_SPCA_eucl(dat,R,init_param)

%
% INV_RESPUESTA_RN computes the inverse of one sample from the PCU
% representation back into the input space. The PCU is defined by the
% manifold described by the global variable "dat".
%
% INV_RESPUESTA_IT_RN requires previous initialization using inicializa_RN.m
% (see script_PCU.m for an example of use).
%
% Inputs:
%
%   "R"          = vector at the PCU representation 
%   "pto_origen" = origin at the input space
%   "Aref"       = local PCA basis at the origin 
%   "Nbins"      = number of bins in the histograms (given by inicializa_RN.m)
%   "Nv"         = number of neighbors in the localities
%
% Outputs:
%
%   "x"    = inverse of R in the input space
%   "Aref" = local PCA basis at x
%

pto_origen = init_param.origin;
Aref = init_param.Aref;
Nbins = init_param.Nbins;
Nv = init_param.k;
muelle = init_param.q;
dist_fuera = init_param.dist_out;

tau = init_param.tau;
eje_principal = init_param.eucl_PC;
criterio = 1;
pto_proximo_principal = init_param.points_on_eucl_PC;
resp_principal = init_param.first_eucl_responses;

[DIM N] = size(dat);

direc = 1;
eje = eje_principal;

%%%%%%%%%%%%%%%%%%%%%%%%
n1 = find(cat(1,eje(:).ref)==fix(R(direc)));
n2 = find(cat(1,eje(:).ref)==sign(R(direc))+ fix(R(direc)));

if isempty(n1),
    %if fix(R(direc))>=0
    %   n1 = find(cat(1,eje(:).ref) == max(cat(1,eje(:).ref)));
    %else
    %   n1 = find(cat(1,eje(:).ref) == min(cat(1,eje(:).ref))); 
    %end
    n1 = find(cat(1,eje(:).ref) == sign(R(direc))*max(sign(R(direc))*cat(1,eje(:).ref)));
end
pto1 = eje(n1(1)).pto;
if isempty(n2),
    pto2 = pto1;
else pto2 = eje(n2(1)).pto;
end

vect21 = pto2-pto1;
dec = abs(R(direc)-fix(R(direc)));
[pto_proximo] = pto1 + dec*vect21;
pto_origen = pto_proximo;
Aref = eje(n1(1)).V_der;

EG(1).eje = eje_principal;
ptos = dat;
Nvn = Nv;
for direc = 2:DIM

    clear resp ptos_proximo
    if direc == 2
        pto_proximo = pto_proximo_principal;
        resp = resp_principal;
    else
        pto_proximo = zeros(size(ptos));
        resp = zeros(1,size(ptos,2));
        for n=1:size(ptos,2)
            [pto_proximo(:,n),resp(:,n)] = punto_en_eje_NLPCA(ptos(:,n),eje);
        end
    end

    aux_res = abs(resp-R(direc-1));
    [sss iii] = sort(aux_res);
    Nvn = round(Nvn/2);
    ptos = dat(:,iii(1:5*Nvn));
    
    eje = lanza_axis(dat,pto_origen,Aref,direc,ptos,Nvn,tau,muelle,dist_fuera);
    % plotea_eje(eje,'go-',2)
    EG(direc).eje = eje;

%     d = zeros(1,size(dat,2));
%     for n=1:size(dat,2)
%         d(n) = dist_pto_a_ejes(dat(:,n),eje);
%     end
%    for nn=1:direc-1, qqq(nn) = length(EG(nn).eje);end
%     [ss ii] = sort(d);
%     Npoints = min(round(size(ptos,2)*1.5),length(ii));
%     dat_tubo = dat(:,ii(1:Npoints));
    
    %%%%%%%%%%%%%%%%%%%%%%%%
    n1 = find(cat(1,eje(:).ref)==fix(R(direc)));
    n2 = find(cat(1,eje(:).ref)==sign(R(direc))+ fix(R(direc)));
    if isempty(n1),
        % n1 = find(cat(1,eje(:).ref) == max(cat(1,eje(:).ref)));
        n1 = find(cat(1,eje(:).ref) == sign(R(direc))*max(sign(R(direc))*cat(1,eje(:).ref)));
    end
    pto1 = eje(n1(1)).pto;
    if isempty(n2),
        pto2 = pto1;
    else pto2 = eje(n2(1)).pto;
    end

    vect21 = pto2-pto1;
    dec = abs(R(direc)-fix(R(direc)));
    
    [pto_proximo] = pto1 + dec*vect21;     
    
    Aref = eje(n1(1)).V_der;
     pto_origen = pto_proximo;
%     plotea_eje(eje,'co-')
%   hold on,plot3(pto_proximo(1,:),pto_proximo(2,:),pto_proximo(3,:),'co-','linewidth',3)
%     hold on,plot3(pto_proximo(1,:),pto_proximo(2,:),pto_proximo(3,:),'kx-')
end



