function [V_izq,V_der,V_ref] = local_axes(dat,pto,Aref,Nv)


%
% ejes_locales_RN - 
% Esta version calcula los vectores incremento para cada direccion
% Estos vectores se calculan a partir de un punto concreto, con
% un numero de vecinos concreto, SIN tau 
%
% [V2_izq,V2_der]=ejes_locales_RN(pto,Aref)
%
%     dat     = SE PASA COMO GLOBAL    
%               muestras en filas (N), dimension en columnas (D), X: NxD
%     pto     = punto entorno al que se calculan los ejes: matriz 1xD
%     Nv      = numero de puntos en la vecindad, tipicamente un 5% de los puntos
%     tau     = factor (entre 0 y 1) para la escala de la longitud de los ejes
%               (v�ase el help de respuesta_rapida_nd.m)
%
%     V_izq   = matriz de vectores incremento 'hacia la izquierda'
%     V_der   = matriz de vectores incremento 'hacia la derecha'
%

% BOLAS ENTORNO AL PUNTO QUE SE LE PASA

[D N] = size(dat);

% Bola redonda
[R,ind] = sort(sqrt(sum((dat-repmat(pto,1,N)).^2)));

% Cogemos una bola mayor de radio RR = sqrt(2)*Maxima Dist para el numero
% de vecinos dados
RR = sqrt(2)*R(Nv);
pos = find(R<=RR);
dat3 = dat(:,ind(1:max(pos)));
% hold on,plot3(dat3(1,:),dat3(2,:),dat3(3,:),'r.','markersize',0.1)
[Dim Nvv] = size(dat3);

% Nos centramos en el punto
dat3c = dat3-repmat(pto,1,Nvv);

% PCA sobre dat3c (bola)
C3 = cov2(dat3c');
[V3,D3] = eig(C3);
% plotea_bases(V3,pto)
% ICA
% [A, V3] = fastica (dat3c);
% V3 = V3./repmat(sqrt(sum(V3.^2,2))',length(V3),1);
% V3 = V3';

V3 = alinea_bases(V3,Aref,1);

V_der = V3;
V_izq = -V3;

% plotea_bases(V_der,pto)
% plotea_bases(V_izq,pto)

V_ref = V3;
